{--------------------------------------------------------}

{   Leitor de telas 3.0 - rotinas de recuperao de strings
{   Autores: Jose' Antonio Borges
{            Xyko Goncalves (Serpro)
{
{
{   Em 15/7/97
{
{--------------------------------------------------------}

{$F+}

unit vox3str;

interface
uses
    dos, crt,
    traduvox, intervox, sintvox, lenumstr, playvox,vox3glob, vox3amb;

procedure MoveString;
procedure GravaString;
procedure Lestring;
procedure BuscaString (func : char);
procedure Capturacarater;

implementation

{----------------------------------------------------------}

{*** funo para agrupar ate 14 caracteres no buffer de teclado ***}

procedure MoveString;
 
{--------------------------------------------------------}

{ *** rotina para jogar uma letra no buffer de teclado ***}

procedure InsBufTeclado (c: char);
var regs: registers;
begin
    with regs do
        begin
            ah := 5;
            ch := 0;
            cl := ord(c);
        end;

    intr ($16, regs);
    inc (totcarac);
end;

{-------------------------------------------------------}

procedure InsBufTecFunc (b1, b2: char);
var regs: registers;
begin
    with regs do
        begin
            ah := 5;
            ch := ord(b2);
            cl := ord(b1);
        end;

    intr ($16, regs);
    inc (totcarac);
    inc (totcarac);
end;

{-------------------------------------------------------}

{*** funo para inserir string ansi selecionado no buffer de teclado ***}

procedure ConverteAnsi;
    begin
    repeat
        case ord (s [indcarac]) of
        39 : begin {apostrofe}
            InsBufTeclado (#39);
            InsBufTeclado (#39);
            end;
        34 : begin {aspas}
            InsBufTeclado (#34);
            InsBufTeclado (#34);
            end;

        227 : begin {a til}
            InsBufTeclado (#126);
            InsBufTeclado (#97);
            end;
        195 : begin {A til}
            InsBufTeclado (#126);
            InsBufTeclado (#65);
            end;

        231 : begin {c cedilha}
            InsBufTeclado (#39);
            InsBufTeclado (#99);
            end;
        199 : begin {C cedilha}
            InsBufTeclado (#39);
            InsBufTeclado (#67);
            end;

        213 : begin {o til}
            InsBufTeclado (#126);
            InsBufTeclado (#79);
            end;
        245 : begin {o til}
            InsBufTeclado (#126);
            InsBufTeclado (#111);
            end;
        209 : begin {N til}
            InsBufTeclado (#126);
            InsBufTeclado (#78);
            end;
        241 : begin {n til}
            InsBufTeclado (#126);
            InsBufTeclado (#110);
            end;

        194 : begin {A circunflexo}
            InsBufTeclado (#94);
            InsBufTeclado (#65);
            end;
        226 : begin {a circunflexo}
            InsBufTeclado (#94);
            InsBufTeclado (#97);
            end;
        202 : begin {E circunflexo}
            InsBufTeclado (#94);
            InsBufTeclado (#69);
            end;
        234 : begin {e circunflexo}
            InsBufTeclado (#94);
            InsBufTeclado (#101);
            end;
        212 : begin {O circunflexo}
            InsBufTeclado (#94);
            InsBufTeclado (#79);
            end;
        244 : begin {o circunflexo}
            InsBufTeclado (#94);
            InsBufTeclado (#111);
            end;

        193 : begin {A agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#65);
            end;
        225 : begin {a agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#97);
            end;
        201 : begin {E agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#69);
            end;
        233 : begin {e agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#101);
            end;
        205 : begin {I agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#73);
            end;
        237 : begin {i agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#105);
            end;
        211 : begin {O agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#79);
            end;
        243 : begin {o agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#111);
            end;
        218 : begin {U agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#85);
            end;
        250 : begin {u agudo}
            InsBufTeclado (#39);
            InsBufTeclado (#117);
            end;
        192 : begin {A grave}
            InsBufTeclado (#96);
            InsBufTeclado (#65);
            end;
        224 : begin {a grave}
            InsBufTeclado (#96);
            InsBufTeclado (#97);
            end;
        200 : begin {E grave}
            InsBufTeclado (#96);
            InsBufTeclado (#69);
            end;
        232 : begin {e grave}
            InsBufTeclado (#96);
            InsBufTeclado (#101);
            end;
        204 : begin {I grave}
            InsBufTeclado (#96);
            InsBufTeclado (#73);
            end;
        236 : begin {i grave}
            InsBufTeclado (#96);
            InsBufTeclado (#105);
            end;
        210 : begin {O grave}
            InsBufTeclado (#96);
            InsBufTeclado (#79);
            end;
        242 : begin {o grave}
            InsBufTeclado (#96);
            InsBufTeclado (#111);
            end;
        217 : begin {U grave}
            InsBufTeclado (#96);
            InsBufTeclado (#85);
            end;
        249 : begin {u grave}
            InsBufTeclado (#96);
            InsBufTeclado (#117);
            end;

        196 : begin {A trema}
            InsBufTeclado (#34);
            InsBufTeclado (#65);
            end;
        228 : begin {a trema}
            InsBufTeclado (#34);
            InsBufTeclado (#97);
            end;
        204 : begin {E trema?}
            InsBufTeclado (#34);
            InsBufTeclado (#69);
            end;
        235 : begin {e trema}
            InsBufTeclado (#34);
            InsBufTeclado (#101);
            end;
        208 : begin {I trema?}
            InsBufTeclado (#34);
            InsBufTeclado (#73);
            end;
        239 : begin {i trema}
            InsBufTeclado (#34);
            InsBufTeclado (#105);
            end;
        214 : begin {O trema}
            InsBufTeclado (#34);
            InsBufTeclado (#79);
            end;
        246 : begin {o trema}
            InsBufTeclado (#34);
            InsBufTeclado (#111);
            end;
        220 : begin {U trema}
            InsBufTeclado (#34);
            InsBufTeclado (#85);
            end;
        252 : begin {u trema}
            InsBufTeclado (#34);
            InsBufTeclado (#117);
            end;

        1 : begin {mscara de seta para cima}
            InsBufTecFunc (#224,#72);
            end;
        4 : begin {mscara de seta para baixo}
            InsBufTecFunc (#224,#80);
            end;
        2 : begin {mscara de seta para esquerda}
            InsBufTecFunc (#224,#75);
            end;
        3 : begin {mscara de seta para cima}
            InsBufTecFunc (#224,#77);
            end;

        else InsBufTeclado (s [indcarac]);
            end;
        inc (indcarac);
        until (totcarac >= 14) or (indcarac > tamstring);
    end;

{-------------------------------------------------------}

{*** funo para inserir string pc selecionado no buffer de teclado ***}

procedure ConvertePc;

    var i : byte;

    begin
    repeat
        InsBufTeclado (s [indcarac]);
        inc (indcarac);
        until (totcarac >= 14) or (indcarac > tamstring);
    sintclek;
    end;

{-------------------------------------------------------}

{*** inicio MoveString ***}

    begin
    totcarac := 0;
    indcarac := 1;
    tamstring := length (s);
    if ansi then
        ConverteAnsi
    else ConvertePc;
    if tamstring >= indcarac then
        begin
        totcarac := (tamstring - indcarac) +1;
        s := copy (s, indcarac, totcarac);
        end
    else begin
        tamstring := 0;
        sintclek;
        end;
    end;

{-----------------------------------------------------------------}

{***  funcao para gravar relacao de strings ***}

procedure GravaString;
    var
    arqstr : text;
    i : byte;

    begin
    if iultimo = 0 then
        begin
        sintsom ('vonaotem');
        exit;
        end;

    assign (arqstr, 'strings.txt');
    {$i-} rewrite (arqstr); {$i+}

    for i := 1 to iultimo do
        begin
        s := vetc [i]. capturado;
        writeln (arqstr, s);
        end;

    close (arqstr);
    end;

{-----------------------------------------------------------------}

{***  funcao para ler relacao de strings ***}

procedure LeString;
    var
    arqstr : text;
    i : byte;

    begin
    assign (arqstr, 'strings.txt');
    {$i-} reset (arqstr); {$i+}
    if ioresult > 0 then
        begin
        sintsom ('vonaotem');
        exit;
        end;

    icap := 0;
    while (not eof (arqstr)) and (icap < 31) do
        begin
        readln (arqstr, s);
        inc (icap);
        vetc [icap]. capturado := s;
        end;

    iultimo := icap;
    icap := 1;
    indstring := 1;
    close (arqstr);
    end;

{*** funcao para controlar strings (1 inclui no buffer de teclado ***}
{***                                2 incluir novo string no meio do
vetor ***}

procedure BuscaString (func : char);
    var
    iletra, i : byte;

{*** inicio buscastring ***}

    begin
    if iultimo < 1 then
        begin
        icap := 0;
        Lestring;
        end;
    if (iultimo < 1) and (icap < 1) then
        exit;

    icap := indstring;;
    s := vetc [indstring]. capturado;
    sintsom ('vostring');
    FalaString;
    iletra := 1;
    repeat
        regs.ax := 0;
        intr ($16, regs);
        c := chr (regs.ax and $ff);
        c2 := chr (regs.ax shr 8);
        case c of
        #$0: begin
            case c2 of
            f2 : begin
                GravaString;
                sintclek;
                exit;
                end;

            f3 : begin
                Lestring;
                sintclek;
                end;

            cima : begin
                if (icap -1) <= 0 then
                    begin
                    icap := 0;
                    iletra := 0;
                    s := '';
                    sintsom ('voultimo')
                    end
                else begin
                    dec (icap);
                    s := vetc [icap]. capturado;
                    falastring;
                    iletra := 1;
                    end;
                end;
            baix : begin
                if icap >= iultimo then
                    begin
                    icap := iultimo +1;
                    iletra := 0;
                    s := '';
                    sintsom ('voultimo')
                    end
                else begin
                    inc (icap);
                    s := vetc [icap]. capturado;
                    falastring;
                    iletra := 1;
                    end;
                end;

            dir : begin
                if (iletra > length (s)) or (length (s) = 0)   then
                    sintbip
                else begin
                    if iletra = 0 then
                        iletra := 1;
                    FalaFonetica (s [iletra]);
                    inc (iletra);
                    end;
                end;

            esq : begin
                if iletra < 2 then
                    sintbip
                else begin
                    dec (iletra);
                    FalaFonetica (s [iletra]);
                    end;
                end;

            del : begin
                sintclek;
                if (icap > 0) and (icap <= iultimo) then
                    begin
                    for i := icap to iultimo do
                        vetc [i] := vetc [i +1];
                    dec (iultimo);
                    end;
                if iultimo < 1 then
                    begin
                    sintsom ('voultimo');
                    exit;
                    end;
                end;

            ins : begin
                if iultimo > 30 then
                    begin
                    sintsom ('vooverfl');
                    exit;
                    end;
                sintsom ('vocaptur');
                s := leteclado;
                inc (iultimo);
                icap := iultimo;
                vetc [icap]. capturado := s;
                sintclek;
                exit;
                end;

            else sintsom ('votecinv');
                end;
            end;

        #13 : begin
            if func = '1' then
                begin
                if s <> '' then
                    begin
                        MoveString;
                    indstring := icap +1;
                    if indstring > iultimo then
                        indstring := 1;
                    exit;
                    end
                else
                    begin
                    sintsom ('vonaoass');
                    c := ' ';
                    end;
                end;
            if func = '2' then
                begin
                if salvains <> '' then
                    begin
                    if iultimo < 30 then
                        begin
                        if icap = 0 then
                            icap := 1;
                        for i := iultimo downto icap do
                            vetc [i +1] := vetc [i];
                        vetc[icap] .capturado := salvains;
                        s := salvains;
                        FalaString;
                        inc (iultimo);
                        sintclek;
                        exit;
                        end
                    else
                        begin
                        sintsom ('vooverfl');
                        exit;
                        end;
                    end
                else
                    begin
                    sintsom ('vonaoass');
                    exit;
                    end;
                end;
            end;

        esc : begin
            sintsom ('voanulad');
            c := ' ';
            exit;
            end;

        else sintsom ('votecinv');
        end;
    until (c = #13) or (c = esc);
    c := ' ';
    end;

{--------------------------------------------------------}

{ *** funcao para capturar strings da tela ***}

procedure CapturaCarater;
    var ultimacol, ultimalin : byte;

    begin
    icap := iultimo;
    if icap > 30 then
        begin
        sintsom ('vooverfl');
        exit;
        end;
    sintsom ('vocaptur');
    ultimalin := 0;
    ultimacol := 0;
    s := '';
    sintcarac (letela (linha, coluna));
    repeat
        regs.ax := 0;
        intr ($16, regs);
        c  := chr (regs.ax and $ff);
        c2 := chr (regs.ax shr 8);
        case c of
        #13 : begin
            inc (icap);
            iultimo := icap;
            if icap = 1 then
                indstring := 1;
            vetc [icap]. capturado := s;
            falastring;
            end;
        'c', 'C' : begin
            if coluna >= janpx2 then
                sintbip;
            if length (s) < 80 then
                begin
                s := s + letela (linha, coluna);
                ultimalin := linha;
                ultimacol := coluna;
                if length (s) > 79 then
                    sintbip
                else begin
                    inc (coluna);
                    sintcarac (letela (linha, coluna));
                    end;
                end
            else sintbip;
            end;
        esc : sintsom ('voanulad');
        #0 : begin
            if length (s) > 80 then
                sintbip
            else begin
                case c2 of
                ins : begin
                    salvains := s;
                    BuscaString ('2');
                    salvains := '';
                    end;

                cima : begin
                    if linha > janpy1 then
                        dec (linha)
                    else sintbip;
                    end;

                baix : begin
                    if linha < janpy2 then
                        inc  (linha)
                    else sintbip;
                    end;

                esq : begin
                if coluna > janpx1 then
                    begin
                    dec (coluna);
                    if (ultimacol = coluna) and (ultimalin = linha) then
                        sintsom ('vopin');
                    falaFonetica (letela (linha, coluna));
                    end
                else begin
                    sintBip;
                    coluna := janpx1;
                    end;
                end;

                dir : begin
                    if coluna < janpx2 then
                        begin
                        inc (coluna);
                        if (coluna = ultimacol) and (linha = ultimalin) then
                            sintsom ('vopin');
                        falaFonetica (letela  (linha, coluna));
                        end
                    else begin
                        sintBip;
                        coluna := janpx2;
                        end;
                end;
                else sintsom ('votecinv');
                end;
                end;
            end;
        else sintsom ('votecinv');
        end;
        until (c = esc) or (c = #13) or (c = ' ');
    c := ' ';
    end;

    end.
